defmodule Traccar.Mixfile do
  use Mix.Project

  def project do
    [app: :traccar,
     version: "0.1.1",
     elixir: "~> 1.7",
     description: "Swagger codegen of Traccar API",
     package: package(),
     build_embedded: Mix.env == :prod,
     start_permanent: Mix.env == :prod,
     deps: deps()]
  end

  # Configuration for the OTP application
  #
  # Type "mix help compile.app" for more information
  def application do
    # Specify extra applications you'll use from Erlang/Elixir
    [extra_applications: [:logger]]
  end

  defp package do
    [
      maintainers: [
        "Fernando Mumbach"
      ],
      licenses: ["apache"],
      links: %{gitlab: "https://gitlab.com/AYVU/traccarex"},
    ]
  end

  # Dependencies can be Hex packages:
  #
  #   {:my_dep, "~> 0.3.0"}
  #
  # Or git/path repositories:
  #
  #   {:my_dep, git: "https://github.com/elixir-lang/my_dep.git", tag: "0.1.0"}
  #
  # Type "mix help deps" for more examples and options
  defp deps do
    [
      {:tesla, "~> 0.8"},
      {:poison, ">= 1.0.0"},

      {:ex_doc, ">= 0.0.0", only: :dev}
    ]
  end
end
